	org $1001-2
	dw $1001
	
	include "!playerv.asm"
	
temp	= $F0	
dest	= $F2
	;
time		= $0EB8
max_raster	= time + 47
max_raster_chr	= time + 40
track_info	= $0F70

Print16	macro addr
	lda #"$"
	jsr $FFD2
	lda #addr >> 8
	jsr $FB10
	lda #addr & 255
	jsr $FB10
	endm
	
	dw $100B,0
	db $9E,"4109",0,0,0
start
	;
	; ---
	;
	jsr $FF4F
	db $93,$90
	db $0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D
	db $0D,$0D
	;db "PRESS ",$9A,"[1]",$90," FOR EFFECT 1",$0D
	db "PRESS ",$9A,"[CURSOR RIGHT]",$90," TO FAST FORWARD",$0D
	db "PRESS ",$9A,"[SPACE]",$90," TO FADE OUT",$0D,$0D
	;
	db "ELAPSED TIME  : 00:00 ( )",$0D
	db "MAXIMUM RASTER: 00    ( )",$0D
	db $90,"MAX. ROOM     : $C000 - $CFFF",$0D
	db $90,"MUSIC         : "
	;
	db 0
	;
	Print16 (music_beg-OFS)
	jsr $FF4F
	db " - ",0
	Print16 (music_end-OFS)
	;
	lda #$00
	sta time+7
	sta max_raster
	;
	lda #$41
	sta $FF19
	lda #$51
	sta $FF15
	;
	; ---
	;
	ldy #$00
	ldx #$00
delay	inx
	bne delay
	iny
	bne delay
	;
	sei
	sta $FF3F
	;
	; ----------
	;
;	lda #$C0
;	sta dest+1
;	ldy #$00
;	sty dest
;cl2	tya
;cl1	sta (dest),y
;	iny
;	bne cl1
;	;    
;	inc dest+1
;	lda dest+1
;	cmp #$FD
;	bne cl2
	;
	jsr PLAYER_FREQ_INIT - OFS
	;
	; ----------
	;
sync0	lda #$BF
	sta $FD30
	sta $FF08
	lda $FF08
	and #$08
	bne sync1
	;
	inc $FF19
	jsr PLAYER - OFS
	jsr INC_TIMER
	jsr dump_track_info
	dec $FF19
	;
sync1	lda $FF1D
	cmp #$40
	bcs sync0
	;
sync2	lda $FF1D
	cmp #$44
	bne sync2
	;
	dec $FF19
	lda $FF1D
	sta r_start+1
	;
	jsr PLAYER - OFS
	;
vol_down
	lda #$00
	beq no_vol_down
	;
vol_delay
	lda #$00
	clc
	adc #$01
	and #$0F
	sta vol_delay+1
	bne no_vol_down
	;
	lda VOLUME
	clc
	adc #$09
	cmp #21*9
	bne do_vol_down
	jmp $FFF6
do_vol_down
	sta VOLUME
no_vol_down
	;
	inc $FF19
	;
	lda $FF1D
	sec
r_start	sbc #$00
	cmp max_raster
	bcc not_larger
	;
	sta max_raster
	;
	and #$0F
	tax
	lda hex_char,x
	sta max_raster_chr+1
	;
	lda max_raster
	lsr a
	lsr a
	lsr a
	lsr a
	tax
	lda hex_char,x
	sta max_raster_chr
	;
not_larger
	;
	jsr INC_TIMER
	;
	jsr dump_track_info
	;
	;LDA $FF12
	;AND #$03
	;JSR $FB10
	;LDA $FF0E
	;JSR $FB10
	;LDA #$0D
	;JSR $FFD2
	;
kdelay	ldy #$00
	beq kcheck
	dey 
	jmp kend
	
kcheck	lda #$7F
	sta $FD30
	sta $FF08
	lda $FF08
	cmp #$EF
	bne x5
	;
	lda #$21
	sta $FF15
	sta vol_down+1
	; do something on keypress
	;
x5	lda #$7F
	sta $FD30
	sta $FF08
	lda $FF08
	cmp #$FE
	bne x6
	;
;	ldx #$00
;effect1	txa
;	pha
;	lda #$CC
;	cmp $FF1D
;	bne *-3
;	cmp $FF1D
;	beq *-3
;	dec $FF19
;	jsr $BD00
;	inc $FF19
;	pla
;	tax
;	inx
;	cpx #50
;	bne effect1
	;
x6	lda #$7F
	sta $FD30
	sta $FF08
	lda $FF08
	cmp #$F7
	bne x7
	;
;	ldx #$00
;effect2	txa
;	pha
;	lda #$CC
;	cmp $FF1D
;	bne *-3
;	cmp $FF1D
;	beq *-3
;	dec $FF19
;	jsr $BE00
;	inc $FF19
;	pla
;	tax
;	inx
;	cpx #$40
;	bne effect2
	;
x7	ldy #$04
kend	sty kdelay+1
	;
	jmp sync0
	;
	
INC_TIMER
	lda time+7
	clc
	adc #$01
	cmp #50
	bne inc1
	;
	ldx #$05
inc2	dex 
	cpx #$02
	beq inc2
	lda time,x
	clc
	adc #$01
	cmp time_end,x
	bne inc3
	lda #$30
inc3	sta time,x
	cmp #$30
	beq inc2
	;
	lda #$00
inc1	sta time+7
	;
	rts
time_end
	db $3A,$3A,$3A,$36,$3A
hex_char
	db "0123456789",1,2,3,4,5,6
	
dump_track_info
	lda #track_info & 255
	sta dest
	lda #track_info >> 8
	sta dest+1
	;
	ldx #$00
dt2	stx x_save+1
	lda CH1_LO,x
	sta temp
	lda CH1_HI,x
	sta temp+1
	;
	ldx temp
	jsr write_word
	jsr add_dest_1
	;
	ldy #$00
dt1	lda (temp),y
	jsr write_byte
	jsr add_dest_1
	iny
	cpy #$08
	bne dt1
	;
	lda #$0B
	jsr add_dest
	;
x_save	ldx #$00
	inx
	cpx #$03
	bne dt2
	;
	rts
	
write_word
	stx x_sav2+1
	jsr write_byte
x_sav2	lda #$00
	;
write_byte
	sty y_save+1
	pha
	lsr a
	lsr a
	lsr a
	lsr a
	tax
	lda hex_char,x
	ldy #$00
	sta (dest),y
	pla
	and #$0F
	tax
	lda hex_char,x
	iny
	sta (dest),y
	;
	lda #$02
	jsr add_dest
y_save	ldy #$00
	rts

add_dest_1
	lda #$01
add_dest
	clc
	adc dest
	sta dest
	bcc *+4
	inc dest+1
	rts
	
	org $C000
OFS = 0	
music_beg
	include "!player.asm"
	include "!player_data.asm"
	include "music.asm"
music_end
	
;[eof]